#include "letters.h"
#include "draw.h"

float letter_A_points[] = {
	     0.982,      0.491, // 0
	    10.642,      0.982, // 1
	     5.567,     16.536, // 2
	     3.111,      8.350, // 3
	     8.022,      8.186, // 4
	     5.730,     16.700  // 5
};
int letter_A_lines[] = {
	0, 3, 0, 0, 0,
	3, 2, 0, 0, 0,
	2, 4, 0, 0, 0,
	4, 1, 0, 0, 0,
	4, 3, 0, 0, 0 
};
float letter_B_points[] = {
	     0.819,      0.982, // 0
	     8.022,      4.093, // 1
	     1.310,     16.700, // 2
	     0.655,      8.841, // 3
	     8.022,     13.261, // 4
	     1.637,      8.677  // 5
};
int letter_B_lines[] = {
	0, 3, 0, 0, 0,
	3, 2, 0, 0, 0,
	2, 4, 0, 0, 0,
	4, 3, 0, 0, 0,
	3, 1, 0, 0, 0,
	1, 0, 0, 0, 0 
};
float letter_C_points[] = {
	     8.186,      1.146, // 0
	     0.982,      9.005, // 1
	     7.531,     16.536, // 2
	     7.859,      0.819, // 3
	     0.819,      9.005, // 4
	     7.531,     16.536  // 5
};
int letter_C_lines[] = {
	1, 2, 0, 0, 0,
	1, 0, 0, 0, 0 
};
float letter_D_points[] = {
	     1.637,      1.310, // 0
	     8.677,      9.005, // 1
	     1.637,     16.536, // 2
	     1.473,     16.536, // 3
	     8.514,      8.514, // 4
	     1.801,      1.146  // 5
};
int letter_D_lines[] = {
	0, 2, 0, 0, 0,
	2, 1, 0, 0, 0,
	1, 0, 0, 0, 0 
};
float letter_E_points[] = {
	     8.022,      0.491, // 0
	     1.473,      9.005, // 1
	     8.350,     15.881, // 2
	     9.332,      8.677, // 3
	     8.022,      0.327, // 4
	     8.350,     16.045  // 5
};
int letter_E_lines[] = {
	2, 1, 0, 0, 0,
	1, 3, 0, 0, 0,
	0, 1, 0, 0, 0 
};
float letter_F_points[] = {
	     1.801,      7.695, // 0
	     1.473,      8.677, // 1
	     1.965,     16.045, // 2
	     9.332,      8.677, // 3
	     9.005,     16.045, // 4
	     1.473,      0.982  // 5
};
int letter_F_lines[] = {
	1, 5, 0, 0, 0,
	1, 3, 0, 0, 0,
	1, 2, 0, 0, 0,
	2, 4, 0, 0, 0 
};
float letter_G_points[] = {
	     1.473,      0.655, // 0
	     4.748,      8.186, // 1
	     1.965,     16.372, // 2
	     9.332,      8.350, // 3
	     9.005,     16.045, // 4
	     9.496,      1.637  // 5
};
int letter_G_lines[] = {
	3, 5, 0, 0, 0,
	5, 0, 0, 0, 0,
	2, 4, 0, 0, 0,
	2, 0, 0, 0, 0,
	1, 3, 0, 0, 0 
};
float letter_H_points[] = {
	     1.637,      0.655, // 0
	     1.637,      8.677, // 1
	     2.128,     16.208, // 2
	    10.151,      8.677, // 3
	     9.005,     16.045, // 4
	     9.332,      1.637  // 5
};
int letter_H_lines[] = {
	2, 1, 0, 0, 0,
	1, 3, 0, 0, 0,
	3, 5, 0, 0, 0,
	0, 1, 0, 0, 0,
	3, 4, 0, 0, 0 
};
float letter_I_points[] = {
	     2.128,      1.310, // 0
	     2.128,     16.536, // 1
	     0.655,      1.473, // 2
	     3.438,      1.310, // 3
	     0.819,     16.536, // 4
	     3.274,     16.700  // 5
};
int letter_I_lines[] = {
	1, 0, 0, 0, 0,
	5, 1, 0, 0, 0,
	1, 4, 0, 0, 0,
	2, 0, 0, 0, 0,
	0, 3, 0, 0, 0 
};
float letter_J_points[] = {
	     4.093,      1.146, // 0
	     7.367,      1.637, // 1
	     8.841,     16.045, // 2
	     1.801,      5.730, // 3
	     3.766,      0.982, // 4
	     7.367,      1.637  // 5
};
int letter_J_lines[] = {
	2, 1, 0, 0, 0,
	1, 0, 0, 0, 0,
	0, 3, 0, 0, 0 
};
float letter_K_points[] = {
	     1.637,      1.146, // 0
	     7.040,      1.310, // 1
	     8.841,     15.390, // 2
	     1.473,     15.226, // 3
	     1.146,      7.695, // 4
	     1.637,      7.695  // 5
};
int letter_K_lines[] = {
	3, 4, 0, 0, 0,
	4, 2, 0, 0, 0,
	4, 1, 0, 0, 0,
	4, 0, 0, 0, 0 
};
float letter_L_points[] = {
	     1.637,      1.146, // 0
	     7.040,      1.310, // 1
	     1.473,     15.226, // 2
	     7.040,      1.146, // 3
	     1.637,      1.310, // 4
	     1.965,     15.390  // 5
};
int letter_L_lines[] = {
	2, 0, 0, 0, 0,
	0, 1, 0, 0, 0 
};
float letter_M_points[] = {
	     1.637,      1.146, // 0
	     5.239,      3.602, // 1
	     1.473,     15.717, // 2
	     8.841,     15.717, // 3
	     9.496,      1.801, // 4
	     5.239,      3.602  // 5
};
int letter_M_lines[] = {
	0, 2, 0, 0, 0,
	2, 1, 0, 0, 0,
	1, 3, 0, 0, 0,
	3, 4, 0, 0, 0 
};
float letter_N_points[] = {
	     1.473,      1.310, // 0
	     8.022,      1.965, // 1
	     1.310,     15.226, // 2
	     8.350,     15.881, // 3
	     1.310,     15.226, // 4
	     7.859,      2.128  // 5
};
int letter_N_lines[] = {
	0, 2, 0, 0, 0,
	2, 1, 0, 0, 0,
	1, 3, 0, 0, 0 
};
float letter_O_points[] = {
	     0.982,      7.695, // 0
	     5.894,      1.146, // 1
	     5.894,     15.881, // 2
	    10.642,     10.642, // 3
	     0.982,      7.531, // 4
	     9.987,     10.151  // 5
};
int letter_O_lines[] = {
	0, 2, 0, 0, 0,
	2, 3, 0, 0, 0,
	3, 1, 0, 0, 0,
	1, 0, 0, 0, 0 
};
float letter_P_points[] = {
	     1.637,      1.310, // 0
	     2.620,      8.677, // 1
	     3.438,     15.717, // 2
	    10.969,     10.478, // 3
	     2.456,      8.677, // 4
	    10.806,     10.478  // 5
};
int letter_P_lines[] = {
	0, 1, 0, 0, 0,
	1, 3, 0, 0, 0,
	3, 2, 0, 0, 0,
	2, 1, 0, 0, 0 
};
float letter_Q_points[] = {
	     5.730,      0.164, // 0
	     1.310,      8.186, // 1
	     5.567,     16.700, // 2
	     9.823,      9.168, // 3
	     8.841,      1.310, // 4
	     6.549,      4.420  // 5
};
int letter_Q_lines[] = {
	0, 1, 0, 0, 0,
	1, 2, 0, 0, 0,
	2, 3, 0, 0, 0,
	3, 0, 0, 0, 0,
	5, 4, 0, 0, 0 
};
float letter_R_points[] = {
	     1.637,      1.473, // 0
	     2.128,      8.022, // 1
	     1.637,     16.700, // 2
	     8.514,     12.443, // 3
	     8.022,      1.310, // 4
	     1.965,      8.186  // 5
};
int letter_R_lines[] = {
	0, 1, 0, 0, 0,
	1, 2, 0, 0, 0,
	2, 3, 0, 0, 0,
	3, 1, 0, 0, 0,
	1, 4, 0, 0, 0 
};
float letter_S_points[] = {
	     2.128,      0.982, // 0
	     7.695,      5.894, // 1
	     1.310,     11.133, // 2
	     8.514,     16.045, // 3
	     7.859,      5.894, // 4
	     1.965,     10.642  // 5
};
int letter_S_lines[] = {
	3, 2, 0, 0, 0,
	2, 1, 0, 0, 0,
	1, 0, 0, 0, 0 
};
float letter_T_points[] = {
	     6.549,      1.637, // 0
	     6.713,     15.390, // 1
	     1.965,     15.717, // 2
	    11.461,     16.045, // 3
	     6.549,     15.390, // 4
	     6.713,      1.801  // 5
};
int letter_T_lines[] = {
	2, 1, 0, 0, 0,
	1, 3, 0, 0, 0,
	1, 0, 0, 0, 0 
};
float letter_U_points[] = {
	     5.894,      1.146, // 0
	     1.801,     16.208, // 1
	     9.823,     15.881, // 2
	     2.128,      4.420, // 3
	     9.168,      4.584, // 4
	     5.894,      1.146  // 5
};
int letter_U_lines[] = {
	1, 3, 0, 0, 0,
	3, 0, 0, 0, 0,
	0, 4, 0, 0, 0,
	4, 2, 0, 0, 0 
};
float letter_V_points[] = {
	     4.748,      0.982, // 0
	     1.310,     16.208, // 1
	     9.168,     16.045, // 2
	     1.473,     16.372, // 3
	     4.257,      1.473, // 4
	     8.677,     16.372  // 5
};
int letter_V_lines[] = {
	1, 0, 0, 0, 0,
	0, 2, 0, 0, 0 
};
float letter_W_points[] = {
	     3.766,      0.819, // 0
	     1.473,     16.372, // 1
	     5.730,     15.062, // 2
	     8.841,      1.310, // 3
	    11.297,     16.208, // 4
	     6.385,     15.226  // 5
};
int letter_W_lines[] = {
	1, 0, 0, 0, 0,
	0, 2, 0, 0, 0,
	2, 3, 0, 0, 0,
	3, 4, 0, 0, 0 
};
float letter_X_points[] = {
	     1.146,      0.982, // 0
	     0.819,     15.554, // 1
	     8.022,      1.146, // 2
	     9.005,     15.881, // 3
	     4.584,      7.859, // 4
	     4.584,      7.859  // 5
};
int letter_X_lines[] = {
	0, 3, 0, 0, 0,
	1, 2, 0, 0, 0 
};
float letter_Y_points[] = {
	     0.819,     15.881, // 0
	     9.005,     15.881, // 1
	     5.075,      1.146, // 2
	     5.075,      8.677, // 3
	     8.841,     15.717, // 4
	     0.982,     15.554  // 5
};
int letter_Y_lines[] = {
	2, 3, 0, 0, 0,
	3, 0, 0, 0, 0,
	3, 1, 0, 0, 0 
};
float letter_Z_points[] = {
	     0.982,     15.881, // 0
	     8.841,     16.208, // 1
	     8.186,      1.801, // 2
	     1.146,      1.637, // 3
	     3.438,      9.496, // 4
	     7.367,      9.332  // 5
};
int letter_Z_lines[] = {
	0, 1, 0, 0, 0,
	1, 3, 0, 0, 0,
	3, 2, 0, 0, 0,
};

float letter___points[] = {
	     3.755,      1.733, // 0
	     6.066,      1.444, // 1
	     8.186,      1.801, // 2
	     1.146,      1.637, // 3
	     2.889,      2.022, // 4
	     5.777,      2.022  // 5
};
int letter___lines[] = {
	0, 0, 0, 0, 0
};

void letters_draw(int x, int y, int c, char *str, char *prev, float in)
{
	float *points[] = {
		letter_A_points,
		letter_B_points,
		letter_C_points,
		letter_D_points,
		letter_E_points,
		letter_F_points,
		letter_G_points,
		letter_H_points,
		letter_I_points,
		letter_J_points,
		letter_K_points,
		letter_L_points,
		letter_M_points,
		letter_N_points,
		letter_O_points,
		letter_P_points,
		letter_Q_points,
		letter_R_points,
		letter_S_points,
		letter_T_points,
		letter_U_points,
		letter_V_points,
		letter_W_points,
		letter_X_points,
		letter_Y_points,
		letter_Z_points
	};
	int n;
	
	if (in > 0.5) {
		char *temp = prev;
		prev = str;
		str = temp;
		in = 1 - in;
	}
	
	for (n = 0; str[n]; n++) {
		float *p = prev[n] == ' ' ? letter___points : points[prev[n] - 'A'];
		
		switch (str[n]) {
			case '_': c_draw_(x, y, points(letter__), lines(letter__), letter___points, p, letter___lines, in, c); break;
			case 'A': c_draw_(x, y, points(letter_A), lines(letter_A), letter_A_points, p, letter_A_lines, in, c); break;
			case 'B': c_draw_(x, y, points(letter_B), lines(letter_B), letter_B_points, p, letter_B_lines, in, c); break;
			case 'C': c_draw_(x, y, points(letter_C), lines(letter_C), letter_C_points, p, letter_C_lines, in, c); break;
			case 'D': c_draw_(x, y, points(letter_D), lines(letter_D), letter_D_points, p, letter_D_lines, in, c); break;
			case 'E': c_draw_(x, y, points(letter_E), lines(letter_E), letter_E_points, p, letter_E_lines, in, c); break;
			case 'F': c_draw_(x, y, points(letter_F), lines(letter_F), letter_F_points, p, letter_F_lines, in, c); break;
			case 'G': c_draw_(x, y, points(letter_G), lines(letter_G), letter_G_points, p, letter_G_lines, in, c); break;
			case 'H': c_draw_(x, y, points(letter_H), lines(letter_H), letter_H_points, p, letter_H_lines, in, c); break;
			case 'I': c_draw_(x, y, points(letter_I), lines(letter_I), letter_I_points, p, letter_I_lines, in, c); break;
			case 'J': c_draw_(x, y, points(letter_J), lines(letter_J), letter_J_points, p, letter_J_lines, in, c); break;
			case 'K': c_draw_(x, y, points(letter_K), lines(letter_K), letter_K_points, p, letter_K_lines, in, c); break;
			case 'L': c_draw_(x, y, points(letter_L), lines(letter_L), letter_L_points, p, letter_L_lines, in, c); break;
			case 'M': c_draw_(x, y, points(letter_M), lines(letter_M), letter_M_points, p, letter_M_lines, in, c); break;
			case 'N': c_draw_(x, y, points(letter_N), lines(letter_N), letter_N_points, p, letter_N_lines, in, c); break;
			case 'O': c_draw_(x, y, points(letter_O), lines(letter_O), letter_O_points, p, letter_O_lines, in, c); break;
			case 'P': c_draw_(x, y, points(letter_P), lines(letter_P), letter_P_points, p, letter_P_lines, in, c); break;
			case 'Q': c_draw_(x, y, points(letter_Q), lines(letter_Q), letter_Q_points, p, letter_Q_lines, in, c); break;
			case 'R': c_draw_(x, y, points(letter_R), lines(letter_R), letter_R_points, p, letter_R_lines, in, c); break;
			case 'S': c_draw_(x, y, points(letter_S), lines(letter_S), letter_S_points, p, letter_S_lines, in, c); break;
			case 'T': c_draw_(x, y, points(letter_T), lines(letter_T), letter_T_points, p, letter_T_lines, in, c); break;
			case 'U': c_draw_(x, y, points(letter_U), lines(letter_U), letter_U_points, p, letter_U_lines, in, c); break;
			case 'V': c_draw_(x, y, points(letter_V), lines(letter_V), letter_V_points, p, letter_V_lines, in, c); break;
			case 'W': c_draw_(x, y, points(letter_W), lines(letter_W), letter_W_points, p, letter_W_lines, in, c); break;
			case 'X': c_draw_(x, y, points(letter_X), lines(letter_X), letter_X_points, p, letter_X_lines, in, c); break;
			case 'Y': c_draw_(x, y, points(letter_Y), lines(letter_Y), letter_Y_points, p, letter_Y_lines, in, c); break;
			case 'Z': c_draw_(x, y, points(letter_Z), lines(letter_Z), letter_Z_points, p, letter_Z_lines, in, c); break;
		}
		x += 12;
	}
}
